# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2017-07-27.      #
#                                                           #
# Ruby Bindings Version 2.1.14                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Measures weight with a load cell
  class BrickletLoadCell < Device
    DEVICE_IDENTIFIER = 253 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Load Cell Bricklet' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletLoadCell#set_weight_callback_period. The parameter is the weight
    # as measured by the load cell.
    # 
    # The CALLBACK_WEIGHT callback is only triggered if the weight has changed since the
    # last triggering.
    CALLBACK_WEIGHT = 17

    # This callback is triggered when the threshold as set by
    # BrickletLoadCell#set_weight_callback_threshold is reached.
    # The parameter is the weight as measured by the load cell.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletLoadCell#set_debounce_period.
    CALLBACK_WEIGHT_REACHED = 18

    FUNCTION_GET_WEIGHT = 1 # :nodoc:
    FUNCTION_SET_WEIGHT_CALLBACK_PERIOD = 2 # :nodoc:
    FUNCTION_GET_WEIGHT_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_SET_WEIGHT_CALLBACK_THRESHOLD = 4 # :nodoc:
    FUNCTION_GET_WEIGHT_CALLBACK_THRESHOLD = 5 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 6 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 7 # :nodoc:
    FUNCTION_SET_MOVING_AVERAGE = 8 # :nodoc:
    FUNCTION_GET_MOVING_AVERAGE = 9 # :nodoc:
    FUNCTION_LED_ON = 10 # :nodoc:
    FUNCTION_LED_OFF = 11 # :nodoc:
    FUNCTION_IS_LED_ON = 12 # :nodoc:
    FUNCTION_CALIBRATE = 13 # :nodoc:
    FUNCTION_TARE = 14 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 15 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 16 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    RATE_10HZ = 0 # :nodoc:
    RATE_80HZ = 1 # :nodoc:
    GAIN_128X = 0 # :nodoc:
    GAIN_64X = 1 # :nodoc:
    GAIN_32X = 2 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 0]

      @response_expected[FUNCTION_GET_WEIGHT] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WEIGHT_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_WEIGHT_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_WEIGHT_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_WEIGHT_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOVING_AVERAGE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOVING_AVERAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_LED_ON] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_LED_OFF] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_LED_ON] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_CALIBRATE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_TARE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_WEIGHT] = 'l'
      @callback_formats[CALLBACK_WEIGHT_REACHED] = 'l'

    end

    # Returns the currently measured weight in grams.
    # 
    # If you want to get the weight periodically, it is recommended
    # to use the CALLBACK_WEIGHT callback and set the period with
    # BrickletLoadCell#set_weight_callback_period.
    def get_weight
      send_request FUNCTION_GET_WEIGHT, [], '', 4, 'l'
    end

    # Sets the period in ms with which the CALLBACK_WEIGHT callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_WEIGHT callback is only triggered if the weight has changed since the
    # last triggering.
    # 
    # The default value is 0.
    def set_weight_callback_period(period)
      send_request FUNCTION_SET_WEIGHT_CALLBACK_PERIOD, [period], 'L', 0, ''
    end

    # Returns the period as set by BrickletLoadCell#set_weight_callback_period.
    def get_weight_callback_period
      send_request FUNCTION_GET_WEIGHT_CALLBACK_PERIOD, [], '', 4, 'L'
    end

    # Sets the thresholds for the CALLBACK_WEIGHT_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the weight is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the weight is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the weight is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the weight is greater than the min value (max is ignored)"
    # 
    # The default value is ('x', 0, 0).
    def set_weight_callback_threshold(option, min, max)
      send_request FUNCTION_SET_WEIGHT_CALLBACK_THRESHOLD, [option, min, max], 'k l l', 0, ''
    end

    # Returns the threshold as set by BrickletLoadCell#set_weight_callback_threshold.
    def get_weight_callback_threshold
      send_request FUNCTION_GET_WEIGHT_CALLBACK_THRESHOLD, [], '', 9, 'k l l'
    end

    # Sets the period in ms with which the threshold callback
    # 
    # * CALLBACK_WEIGHT_REACHED
    # 
    # is triggered, if the threshold
    # 
    # * BrickletLoadCell#set_weight_callback_threshold
    # 
    # keeps being reached.
    # 
    # The default value is 100.
    def set_debounce_period(debounce)
      send_request FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 0, ''
    end

    # Returns the debounce period as set by BrickletLoadCell#set_debounce_period.
    def get_debounce_period
      send_request FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 4, 'L'
    end

    # Sets the length of a `moving averaging <https://en.wikipedia.org/wiki/Moving_average>`__
    # for the weight value.
    # 
    # Setting the length to 1 will turn the averaging off. With less
    # averaging, there is more noise on the data.
    # 
    # The range for the averaging is 1-40.
    # 
    # The default value is 4.
    def set_moving_average(average)
      send_request FUNCTION_SET_MOVING_AVERAGE, [average], 'C', 0, ''
    end

    # Returns the length moving average as set by BrickletLoadCell#set_moving_average.
    def get_moving_average
      send_request FUNCTION_GET_MOVING_AVERAGE, [], '', 1, 'C'
    end

    # Turns the LED on.
    def led_on
      send_request FUNCTION_LED_ON, [], '', 0, ''
    end

    # Turns the LED off.
    def led_off
      send_request FUNCTION_LED_OFF, [], '', 0, ''
    end

    # Returns *true* if the led is on, *false* otherwise.
    def is_led_on
      send_request FUNCTION_IS_LED_ON, [], '', 1, '?'
    end

    # To calibrate your Load Cell Bricklet you have to
    # 
    # * empty the scale and call this function with 0 and
    # * add a known weight to the scale and call this function with the weight in
    #   grams.
    # 
    # The calibration is saved in the EEPROM of the Bricklet and only
    # needs to be done once.
    # 
    # We recommend to use the Brick Viewer for calibration, you don't need
    # to call this function in your source code.
    def calibrate(weight)
      send_request FUNCTION_CALIBRATE, [weight], 'L', 0, ''
    end

    # Sets the currently measured weight as tare weight.
    def tare
      send_request FUNCTION_TARE, [], '', 0, ''
    end

    # The measurement rate and gain are configurable.
    # 
    # The rate can be either 10Hz or 80Hz. A faster rate will produce more noise.
    # It is additionally possible to add a moving average
    # (see BrickletLoadCell#set_moving_average) to the measurements.
    # 
    # The gain can be 128x, 64x or 32x. It represents a measurement range of
    # ±20mV, ±40mV and ±80mV respectively. The Load Cell Bricklet uses an
    # excitation voltage of 5V and most load cells use an output of 2mV/V. That
    # means the voltage range is ±15mV for most load cells (i.e. gain of 128x
    # is best). If you don't know what all of this means you should keep it at
    # 128x, it will most likely be correct.
    # 
    # The configuration is saved in the EEPROM of the Bricklet and only
    # needs to be done once.
    # 
    # We recommend to use the Brick Viewer for configuration, you don't need
    # to call this function in your source code.
    # 
    # The default rate is 10Hz and the default gain is 128x.
    def set_configuration(rate, gain)
      send_request FUNCTION_SET_CONFIGURATION, [rate, gain], 'C C', 0, ''
    end

    # Returns the configuration as set by BrickletLoadCell#set_configuration.
    def get_configuration
      send_request FUNCTION_GET_CONFIGURATION, [], '', 2, 'C C'
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S'
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
